!= Module DynFunc
!
! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu 
! Version::   $Id: dynamic_velx.f90,v 1.1 2011-04-26 04:08:10 sugiyama Exp $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥϳز׻뤿ɬפȤʤؿ«ͤ⥸塼
!Ūˤϰʲι׻뤿δؿǼ.  
!  * ή
!  * Ϲ
!  * Ϲ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ʡؿζΥˤ, 2 ٤ΥۤѤƤ뤿, Ϲη׻ץˤ differentiate_center4 ⥸塼ꤹ뤳ȤϤǤʤΤ.
!
!== Future Plans
!

module Dynamic_velx
  !
  !۳Ѥϳزγƹη׻⥸塼. 
  !Ūˤϰʲι׻뤿δؿǼ.  
  !  * ή
  !  * Ϲ
  !  * Ϲ
  !

  !⥸塼ɤ߹
  use dc_types, only: DP

  use gridset, only:  imin,           &! x β
    &                 imax,           &! x ξ
    &                 jmin,           &! y β
    &                 jmax,           &! y ξ
    &                 kmin,           &! z β
    &                 kmax             ! z ξ
  use basicset, only: xyz_PotTempBasicZ   !ܾβ
  use constants,only: CpDry,             &!ʬǮ
    &                 Grav,              &!ϲ®
    &                 Nu,                &!
    &                 NuH2,              &!
    &                 NuV2
  use axesset, only: &
    &                xyz_avr_pyz, xyr_avr_pyr, xqz_avr_pqz, &
    &                pyz_avr_xyz, pyr_avr_xyr, pqz_avr_xqz, &
    &                xyz_avr_xqz, pyz_avr_pqz, xyr_avr_xqr, &
    &                xqz_avr_xyz, pqz_avr_pyz, xqr_avr_xyr, &
    &                xyz_avr_xyr, pyz_avr_pyr, xqz_avr_xqr, &
    &                xyr_avr_xyz, pyr_avr_pyz, xqr_avr_xqz 

  !ۤηػ
  implicit none

  !°λ
  private

  !ή׻Τδؿ public ˤ
  public tendency_dynamic_velx_long
  public tendency_dynamic_velx_short


contains

  subroutine Tendency_Dynamic_VelX_Long(                          &
    &            pyz_VelXBl, pyz_VelXNl, xqz_VelYNl, xyr_VelZNl, &
    &            pyz_Dyn)
    
    implicit none

    real(DP), intent(in)  :: pyz_VelXBl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: pyz_VelXNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xqz_VelYNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyr_VelZNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(out) :: pyz_Dyn(imin:imax, jmin:jmax, kmin:kmax)

    real(DP) :: pyz_Adv(imin:imax, jmin:jmax, kmin:kmax)
    real(DP) :: pyz_Diff(imin:imax, jmin:jmax, kmin:kmax)
    real(DP) :: pyz_Turb(imin:imax, jmin:jmax, kmin:kmax)

    pyz_Adv  = pyz_AdvVelX(pyz_VelXNl, xqz_VelYNl, xyr_VelZNl) 
    pyz_Diff = pyz_NumDiffVelX(pyz_VelXBl)

    pyz_Dyn = pyz_Adv + pyz_Diff 
    
  end subroutine Tendency_Dynamic_VelX_Long


  subroutine Tendency_Dynamic_VelX_Short(                          &
    &            pyz_VelXNs, xqz_VelYNs, xyr_VelZNs, xyz_ExnerNs, &
    &            pyz_Dyn)
    
    implicit none

    real(DP), intent(in)  :: pyz_VelXNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xqz_VelYNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyr_VelZNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyz_ExnerNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(out) :: pyz_Dyn(imin:imax, jmin:jmax, kmin:kmax)

    pyz_Dyn = - pyz_GradPi(xyz_ExnerNs, pyz_VelXNs, xqz_VelYNs, xyr_VelZNs)
    
  end subroutine Tendency_Dynamic_VelX_Short
  
!!!------------------------------------------------------------------------!!!
  function pyz_AdvVelX(pyz_VelX, xqz_VelY, xyr_VelZ)
    !
    ! z ȾʻҤ줿ˤή׻
    !
    
    !⥸塼ɤ߹
    use xyz_deriv_c4_module, only: xyz_dx_pyz, pqz_dy_pyz, pyr_dz_pyz

    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: pyz_VelX &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ʿ®
    real(DP), intent(in) :: xqz_VelY &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ʿ®
    real(DP), intent(in) :: xyr_VelZ &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ľ®
    real(DP)             :: pyz_AdvVelX(imin:imax,jmin:jmax,kmin:kmax)
                                                        !ʿΰή
    
!    pz_AdvVelX = 0.0d0  !

    pyz_AdvVelX =                                                 &
      & - pyz_VelX * pyz_avr_xyz( xyz_dx_pyz( pyz_VelX ) )        &
      & - pyz_avr_pqz( pqz_avr_xqz( xqz_VelY ) * pqz_dy_pyz( pyz_VelX ) ) &
      & - pyz_avr_pyr( pyr_avr_xyr( xyr_VelZ ) * pyr_dz_pyz( pyz_VelX ) )

    
  end function pyz_AdvVelX


!!!------------------------------------------------------------------------!!!
  function pyz_GradPi(xyz_Exner, pyz_VelX, xqz_VelY, xyr_VelZ)
    !
    ! z ȾʻҤ줿ǤΰϷϹη׻. 
    ! ȸޤ᤿꼰Ƥ뤳Ȥ.
    !
    
    !⥸塼ɤ߹

    use xyz_deriv_module, only: xyz_dx_pyz, xyz_dy_xqz, xyz_dz_xyr, pyz_dx_xyz
        
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: xyz_Exner &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʡؿξ
    real(DP), intent(in) :: pyz_VelX &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʿ®
    real(DP), intent(in) :: xqz_VelY &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʿ®
    real(DP), intent(in) :: xyr_VelZ &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !ľ®
    real(DP)             :: pyz_GradPi &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !Ϸ
    real(DP)             :: xyz_DivVel &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !®٤μ«

    !®٤μ«
    xyz_DivVel = xyz_dx_pyz( pyz_VelX ) + xyz_dy_xqz( xqz_VelY ) &
      &          + xyz_dz_xyr( xyr_VelZ )
    
    !Ϸ
    pyz_GradPi =  &
      & pyz_avr_xyz( CpDry * xyz_PotTempBasicZ )    &
      &   * ( pyz_dx_xyz( xyz_Exner ) &
      &       - pyz_dx_xyz( Nu * xyz_DivVel ) )  
    
  end function pyz_GradPi


!!!-------------------------------------------------------------------!!!
  function pyz_NumDiffVelX(pyz_VarX)
    !
    ! z ȾʻҤ줿ǤοͳȻɾ
    !
    use xyz_deriv_module, only:  pyz_dx_xyz, xyz_dx_pyz, pyz_dy_pqz, pqz_dy_pyz, pyz_dz_pyr, pyr_dz_pyz
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: pyz_VarX &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                                    !ʪ
    real(DP)             :: pyz_NumDiffVelX &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                                    !ͳȻ
    
    pyz_NumDiffVelX = &
      &   NuH2 * ( pyz_dx_xyz( xyz_dx_pyz( pyz_VarX ) ) ) &
      & + NuH2 * ( pyz_dy_pqz( pqz_dy_pyz( pyz_VarX ) ) ) &
      & + NuV2 * ( pyz_dz_pyr( pyr_dz_pyz( pyz_VarX ) ) )
    
  end function pyz_NumDiffVelX
  
  
end module Dynamic_velx
