!= Module DynFunc
!
! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu 
! Version::   $Id: dynamic_velz.f90,v 1.1 2011-04-26 04:08:10 sugiyama Exp $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥϳز׻뤿ɬפȤʤؿ«ͤ⥸塼
!Ūˤϰʲι׻뤿δؿǼ.  
!  * ή
!  * Ϲ
!  * Ϲ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ʡؿζΥˤ, 2 ٤ΥۤѤƤ뤿, Ϲη׻ץˤ differentiate_center4 ⥸塼ꤹ뤳ȤϤǤʤΤ.
!
!== Future Plans
!

module dynamic_velz
  !
  !۳Ѥϳزγƹη׻⥸塼. 
  !Ūˤϰʲι׻뤿δؿǼ.  
  !  * ή
  !  * Ϲ
  !  * Ϲ
  !

  !⥸塼ɤ߹
  use dc_types, only: DP

  use gridset, only:  imin,           &! x β
    &                 imax,           &! x ξ
    &                 jmin,           &! y β
    &                 jmax,           &! y ξ
    &                 kmin,           &! z β
    &                 kmax,           &! z ξ
    &                 nf              !
  use basicset, only: xyz_PotTempBasicZ   !ܾβ
  use constants,only: CpDry,             &!ʬǮ
    &                 Grav,              &!ϲ®
    &                 MolWtDry,          &!ʬʬ
    &                 Nu, NuH2, NuV2 
  use moistset, only: CondNum,          &!ŷο
    &                 IdxCG,            &!ŷ()ź
    &                 IdxCC,            &!ŷ()ź
    &                 GasNum,           &!Το
    &                 IdxG,             &!Τź
    &                 IdxNH3,           &!NH3()ź
    &                 IdxH2S,           &!H2S()ź
    &                 SpcWetID,         &!ŽʬID
    &                 MolWtWet           !Žʬʬ
  use basicset, only:  &
    &                 xyz_PotTempBasicZ,  &!ܾβ
    &                 xyz_EffMolWtBasicZ, &!ܾʬ̸
    &                 xyz_ExnerBasicZ,    &!̵ܾ
    &                 xyza_MixRtBasicZ     !ܾκ
  use axesset, only: x_dx, y_dy, z_dz, &
    &                xyz_avr_pyz, xyr_avr_pyr, xqz_avr_pqz, &
    &                pyz_avr_xyz, pyr_avr_xyr, pqz_avr_xqz, &
    &                xyz_avr_xqz, pyz_avr_pqz, xyr_avr_xqr, &
    &                xqz_avr_xyz, pqz_avr_pyz, xqr_avr_xyr, &
    &                xyz_avr_xyr, pyz_avr_pyr, xqz_avr_xqr, &
    &                xyr_avr_xyz, pyr_avr_pyz, xqr_avr_xqz 

  !ۤηػ
  implicit none

  !°λ
  private

  !ή׻Τδؿ public ˤ
  public Tendency_Dynamic_VelZ_Long
  public Tendency_Dynamic_VelZ_Long
  public Dynamic_VelZ_init

  real(DP), allocatable :: xyr_MixRtBasicZPerMolWt(:,:,:)
                              !ܾκ / ʬ 
  real(DP), allocatable :: xyr_MixRtBasicZ(:,:,:)
                              !ܾκ
  save xyr_MixRtBasicZPerMolWt
  save xyr_MixRtBasicZ 

contains

  subroutine Dynamic_VelZ_init( )

    !ۤηػ
    implicit none

    !ѿ
    integer               :: s
    real(DP), allocatable :: xyza_MixRtBasicZPerMolWt(:,:,:,:)
                                  !ܾκ / ʬ
    real(DP), allocatable :: xyz_MixRtBasicZPerMolWt(:,:,:)
                              !ܾκ / ʬ 
    real(DP), allocatable :: xyz_MixRtBasicZ(:,:,:)
                              !ܾκ

    !-----------------------------------------------------------
    ! ν. 
    !
    allocate( &
      & xyza_MixRtBasicZPerMolWt(imin:imax,jmin:jmax, kmin:kmax, GasNum),  &
      & xyr_MixRtBasicZPerMolWt(imin:imax,jmin:jmax,kmin:kmax),           &
      & xyz_MixRtBasicZPerMolWt(imin:imax,jmin:jmax,kmin:kmax),           &
      & xyr_MixRtBasicZ(imin:imax,jmin:jmax,kmin:kmax),                   &
      & xyz_MixRtBasicZ(imin:imax,jmin:jmax,kmin:kmax)                    &
      & )
    
    xyza_MixRtBasicZPerMolWt = 0.0d0
    xyr_MixRtBasicZPerMolWt = 0.0d0
    xyz_MixRtBasicZPerMolWt = 0.0d0
    xyr_MixRtBasicZ = 0.0d0
    xyz_MixRtBasicZ = 0.0d0

    do s = 1, GasNum
      xyza_MixRtBasicZPerMolWt(:,:,:,s) = &
        & xyza_MixRtBasicZ(:,:,:,IdxG(s)) / MolWtWet(IdxG(s))
    end do

    xyz_MixRtBasicZPerMolWt = sum(xyza_MixRtBasicZPerMolWt, 4) 
    xyr_MixRtBasicZPerMolWt = xyr_avr_xyz( sum(xyza_MixRtBasicZPerMolWt, 4) )
    xyz_MixRtBasicZ         = sum(xyza_MixRtBasicZ, 4) 
    xyr_MixRtBasicZ         = xyr_avr_xyz( sum(xyza_MixRtBasicZ, 4) )     
    
  end subroutine Dynamic_VelZ_init


  subroutine Tendency_Dynamic_VelZ_Long(                         &
    &            xyr_VelZBl, pyz_VelXNl, xqz_VelYNl, xyr_VelZNl, &
    &            xyz_PotTempNl, xyza_MixRtNl,                    &
    &            sw_moist, xyr_Dyn)
    
    implicit none

    real(DP), intent(in)  :: xyr_VelZBl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: pyz_VelXNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xqz_VelYNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyr_VelZNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyz_PotTempNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyza_MixRtNl(imin:imax, jmin:jmax, kmin:kmax, nf)
    logical,  intent(in)  :: sw_moist
    real(DP), intent(out) :: xyr_Dyn(imin:imax, jmin:jmax, kmin:kmax)
    
    real(DP) :: xyr_Adv(imin:imax, jmin:jmax, kmin:kmax)
    real(DP) :: xyr_Diff(imin:imax, jmin:jmax, kmin:kmax)
    real(DP) :: xyr_BuoyT(imin:imax, jmin:jmax, kmin:kmax)
    real(DP) :: xyr_BuoyM(imin:imax, jmin:jmax, kmin:kmax)
    real(DP) :: xyr_BuoyD(imin:imax, jmin:jmax, kmin:kmax)
    
    xyr_Adv  = xyr_AdvVelZ(pyz_VelXNl, xqz_VelYNl, xyr_VelZNl)
    xyr_Diff = xyr_NumDiffVelZ(xyr_VelZBl)
!    xyr_Turb = xyr_TurbVelZ(xyz_KmBl, pyz_VelXBl, xqz_VelYBl, xyr_VelZBl) 

    xyr_BuoyT = xyr_Buoy(xyz_PotTempNl)
    if (sw_moist) then 
      xyr_BuoyM = xyr_BuoyMolWt(xyza_MixRtNl)
      xyr_BuoyD = xyr_BuoyDrag(xyza_MixRtNl) 
    else
      xyr_BuoyM = 0.0d0
      xyr_BuoyD = 0.0d0
    end if
    xyr_Dyn = xyr_Adv + xyr_Diff + xyr_BuoyT + xyr_BuoyM + xyr_BuoyD

  end subroutine Tendency_Dynamic_VelZ_Long

  
  subroutine Tendency_Dynamic_VelZ_Short(              &
    &            pyz_VelXNs, xqz_VelYNs, xyr_VelZNs,  &
    &            xyz_ExnerNs, xyz_ExnerAs,            &
    &            xyr_Dyn)
    
    implicit none

    real(DP), intent(in)  :: pyz_VelXNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xqz_VelYNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyr_VelZNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyz_ExnerNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyz_ExnerAs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(out) :: xyr_Dyn(imin:imax, jmin:jmax, kmin:kmax)

    xyr_Dyn = - xyr_GradPi(xyz_ExnerAs,xyz_ExnerNs, pyz_VelXNs, xqz_VelYNs, xyr_VelZNs)

  end subroutine Tendency_Dynamic_VelZ_Short
  

!!!------------------------------------------------------------------------!!!
  function xyr_AdvVelZ(pyz_VelX, xqz_VelY, xyr_VelZ)
    !
    ! x ȾʻҤ줿ˤή׻
    !
    
    !⥸塼ɤ߹
    use xyz_deriv_c4_module, only: pyr_dx_xyr, xqr_dy_xyr, xyz_dz_xyr
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: pyz_VelX &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ʿ®
    real(DP), intent(in) :: xqz_VelY &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ʿ®
    real(DP), intent(in) :: xyr_VelZ &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ľ®
    real(DP)             :: xyr_AdvVelZ &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ľΰή
  
!    xr_AdvVelZ = 0.0d0  !
    xyr_AdvVelZ =                                                 &
      & - xyr_avr_pyr( pyr_avr_pyz( pyz_VelX ) * pyr_dx_xyr( xyr_VelZ ) ) &
      & - xyr_avr_xqr( xqr_avr_xqz( xqz_VelY ) * xqr_dy_xyr( xyr_VelZ ) ) &
      & - xyr_VelZ * xyr_avr_xyz( xyz_dz_xyr( xyr_VelZ ) )
    
  end function xyr_AdvVelZ

 
!!!------------------------------------------------------------------------!!!
  function xyr_Buoy(xyz_PotTemp)
    !
    ! ľαư˸Ϲ׻

    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in)  :: xyz_PotTemp(imin:imax,jmin:jmax,kmin:kmax)
                                               !̾
    real(DP)              :: xyr_Buoy &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !Ϲ

!    !
!    xr_Buoy = 0.0d0

    !Ϲη׻
    xyr_Buoy = Grav * xyr_avr_xyz(xyz_PotTemp / xyz_PotTempBasicZ)

  end function xyr_Buoy

!!!------------------------------------------------------------------------!!!
  function xyr_BuoyMolWt(xyza_MixRt)
    !
    ! ľαư˸ϹΤ, 
    ! ʬ̤θ̤
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in)  :: xyza_MixRt(imin:imax,jmin:jmax,kmin:kmax, nf)
                                               !Žʬκ
    real(DP) :: xyr_BuoyMolWt(imin:imax,jmin:jmax,kmin:kmax)
                                               !Ϲ(ʬ̸)
    real(DP) :: xyza_MixRtPerMolWt(imin:imax,jmin:jmax, kmin:kmax, GasNum)
                                               !/ʬ
    integer              :: s
    
    !
    xyr_BuoyMolWt           = 0.0d0
    
    !ν. ΤΤ
    do s = 1, GasNum
      xyza_MixRtPerMolWt(:,:,:,s) = xyza_MixRt(:,:,:,IdxG(s)) / MolWtWet(IdxG(s))
    end do
    
    !Ϲη׻
    xyr_BuoyMolWt =                                               &
      & + Grav * xyr_avr_xyz( sum(xyza_MixRtPerMolWt, 4) )        &
      &    / ( 1.0d0 / MolWtDry + xyr_MixRtBasicZPerMolWt )       &
      & - Grav * xyr_avr_xyz( sum(xyza_MixRt(:,:,:,1:GasNum), 4) )&
      &    / ( 1.0d0 + xyr_MixRtBasicZ )

  end function xyr_BuoyMolWt

!!!------------------------------------------------------------------------!!!
  function xyr_BuoyDrag(xyza_MixRt) 
    !
    ! ľαư˸ϹΤ, 
    ! ŤΤθ̤
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in)  :: xyza_MixRt(imin:imax,jmin:jmax,kmin:kmax, nf)
                                               !Žʬκ
    real(DP) :: xyr_BuoyDrag(imin:imax,jmin:jmax,kmin:kmax)
                                               !Ϲ(ʬ̸)
    !
    xyr_BuoyDrag           = 0.0d0

    !Ϲη׻
    xyr_BuoyDrag =                                                     &
      & - Grav * xyr_avr_xyz( sum(xyza_MixRt(:,:,:,GasNum+1:nf), 4) ) &
      &    / ( 1.0d0 + xyr_MixRtBasicZ )

  end function xyr_BuoyDrag

!!!--------------------------------------------------------------------!!!
  function xyr_GradPi(xyz_ExnerA, xyz_ExnerN, pyz_VelX, xqz_VelY, xyr_VelZ)
    !
    ! x ȾʻҤ줿ǤΰϷϹη׻. 
    ! 󥯡˥륽ˡѤ뤿,    +ӤǤ
    ! ʡؿͤȤƼ.
    ! ȸޤ᤿꼰Ƥ뤳Ȥ.
    !

    ! ⥸塼ɤ߹
    use xyz_deriv_module, only: xyz_dx_pyz, xyz_dy_xqz, xyz_dz_xyr, &
      &                         xyr_dz_xyz, xyr_dz_xyz, xyr_dz_xyz


    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in)  :: xyz_ExnerA &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʡؿξ
    real(DP), intent(in)  :: xyz_ExnerN &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʡؿξ
    real(DP), intent(in)  :: pyz_VelX &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʿ®
    real(DP), intent(in)  :: xqz_VelY &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʿ®
    real(DP), intent(in)  :: xyr_VelZ &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !ľ®
    real(DP)              :: xyr_GradPi &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !Ϸ
    real(DP)              :: xyz_DivVel &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !®٤μ«
    real(DP)               :: beta  = 5.0d-1   !󥯥˥륽ˡʤ 0.5
                                               !ˡʤ 1

    !®٤μ«
    xyz_DivVel =  xyz_dx_pyz( pyz_VelX )   &
      &           + xyz_dy_xqz( xqz_VelY ) &
      &           + xyz_dz_xyr( xyr_VelZ )
    
    !® w ΰϸ
!    xyr_GradPi = 0.0d0
    xyr_GradPi =   &
      & xyr_avr_xyz(CpDry * xyz_PotTempBasicZ )   &
      &   * (                                                      &
      &       beta * xyr_dz_xyz( xyz_ExnerA )                         &
      &       + (1.0d0 - beta) * xyr_dz_xyz( xyz_ExnerN )             &
      &       - xyr_dz_xyz( Nu * xyz_DivVel )                  &
      &     )                                              
    
  end function xyr_GradPi
  

!!!-------------------------------------------------------------------!!!  
  function xyr_NumDiffVelZ(xyr_VarZ)
    !
    ! x ȾʻҤ줿ǤοͳȻɾ
    !

    ! ⥸塼ɤ߹
    use xyz_deriv_module, only: xyr_dx_pyr, pyr_dx_xyr, xyr_dy_xqr, xqr_dy_xyr, xyr_dz_xyz, xyz_dz_xyr
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: xyr_VarZ(imin:imax,jmin:jmax,kmin:kmax)
                                                    !ʪ
    real(DP)             :: xyr_NumDiffVelZ(imin:imax,jmin:jmax,kmin:kmax)
                                                    !ͳȻ

    xyr_NumDiffVelZ = &
      &   NuH2 * ( xyr_dx_pyr( pyr_dx_xyr( xyr_VarZ ) ) ) &
      & + NuH2 * ( xyr_dy_xqr( xqr_dy_xyr( xyr_VarZ ) ) ) & 
      & + NuV2 * ( xyr_dz_xyz( xyz_dz_xyr( xyr_VarZ ) ) )
    
  end function xyr_NumDiffVelZ
 
end module Dynamic_velz

