!= Module BasicEnvInit
!
! Authors::   SUGIYAMA Koichiro, ODAKA Masatsugu
! Version::   $Id: initialdata_basic.f90,v 1.1 2011-04-26 04:08:10 sugiyama Exp $
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥեȤδܾꤹ뤿ѿȷ⥸塼
!   * BasicEnvFile_init: ܾͤ netCDF ե뤫
!   * BasicEnvCalc_Init: ܾξ Namelist ͤ׻
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
module initialdata_basic
  !
  ! ǥեȤδܾ뤿Υ롼

  !⥸塼ɤ߹
  use dc_types,      only: STRING, DP
  use dc_message, only: MessageNotify
  use gridset_3d,  only: kmin, kmax, &! X ξ¡
    &                 na,            &!Žʬο
    &                 z_Z,           &!顼ʻǤι
    &                 r_dz            !Z γʻֳ
  use basicset_3d, only: &
    &                 MolWtDry,      &!ʬʬ
    &                 Grav,          &!ϲ®
    &                 SpcWetMolFr,   &!Žʬν
    &                 GasRUniv        !
  use eccm_3d,  only: ECCM_Dry,      &!
    &                 ECCM_Wet              
    
  !ۤηػ
  implicit none

  !ǥեȤ private
  private

  real(8), save  :: Humidity = 0.0d0        !ܾμ 
!  real(8), save  :: TempSfc   = 300.0d0     !ɽ̲       [K]
!  real(8), save  :: PressSfc  = 965.0d2     !ɽ̰       [Pa]
  real(8), save  :: TempStrat = 100.0d0     !طβ [k]
  real(8), save  :: HeightStrat = 18.0d3    !طι [k]
  real(8), save  :: Dhight = 5.0d3          !ŤߴؿΥѥ᡼ [m]
  integer, save, public :: ID_FlagInitialdataBasic = 0
  integer, parameter, public :: ID_FlagInitialDataBasic_dry = 1
  integer, parameter, public :: ID_FlagInitialDataBasic_moist = 2

  ! public
  public initialdata_basic_nml
  public initialdata_basic_dry
  public initialdata_basic_moist
  public initialdata_basic_strat
    
contains

  subroutine initialdata_basic_nml(cfgfile)
    ! nml ɤ߹
    !
    use dc_iounit,     only : FileOpen    

    implicit none

    character(STRING), intent(in) :: cfgfile    
    integer                       :: unit     !ֹ
    character(STRING)  :: FlagInitialdataBasic = ""
    
    NAMELIST /initialdata_basic/ &
      & FlagInitialDataBasic, Humidity, TempStrat, HeightStrat, Dhight
    
    call FileOpen(unit, file=cfgfile, mode='r')
    read(unit, NML=initialdata_basic)
    close(unit)

    if (FlagInitialdataBasic == "moist") then 
      ID_FlagInitialdataBasic = ID_FlagInitialdataBasic_moist
    elseif (FlagInitialdataBasic == "dry") then
      ID_FlagInitialdataBasic = ID_FlagInitialdataBasic_dry
    end if    

  end subroutine initialdata_basic_nml


  subroutine initialdata_basic_dry( z_TempBasicZ, z_PressBasicZ, za_MolFr )

    implicit none

    real(8), intent(out) :: z_TempBasicZ(kmin:kmax)
    real(8), intent(out) :: z_PressBasicZ(kmin:kmax)
    real(8), intent(out) :: za_MolFr(kmin:kmax, 1:na)
    
    call eccm_dry( SpcWetMolFr(1:na), Humidity, z_TempBasicZ, z_PressBasicZ, za_MolFr )

  end subroutine initialdata_basic_dry


  subroutine initialdata_basic_moist( z_TempBasicZ, z_PressBasicZ, za_MolFr )

    implicit none

    real(8), intent(out) :: z_TempBasicZ(kmin:kmax)
    real(8), intent(out) :: z_PressBasicZ(kmin:kmax)
    real(8), intent(out) :: za_MolFr(kmin:kmax, 1:na)
    
    call eccm_wet( SpcWetMolFr(1:na), Humidity, z_TempBasicZ, z_PressBasicZ, za_MolFr )
    
  end subroutine initialdata_basic_moist

  
  subroutine initialdata_basic_strat(z_TempBasicZ, z_PressBasicZ)
    !
    implicit none
    
    real(8), intent(inout) :: z_TempBasicZ(kmin:kmax)
    real(8), intent(inout) :: z_PressBasicZ(kmin:kmax)
    real(8) :: z_DTempDZ(kmin:kmax)
    real(8) :: DTempDZ
    real(8) :: Weight
    real(8) :: tmp
    integer :: k    
    
    do k = 1, kmax-1
      z_DTempDZ(k) = (z_TempBasicZ(k) - z_TempBasicZ(k-1)) / r_dz(k-1)
    end do
    
    ! ή̤ΰ
    !   ̤絤Ȥ. 絤絤ؤܤ 
    !   tanh ѤƤʤ餫ˤĤʤ
    do k = 1, kmax
      
      !ŤߤĤδؿѰ. tanh Ѥ
      Weight = ( tanh( (z_Z(k) - HeightStrat ) / Dhight ) + 1.0d0 ) * 5.0d-1
      
      !ͤȤƲ٤׻. ̤Ǥ TempStrat 絤˶Ť
      tmp =  z_TempBasicZ(k) 
      z_TempBasicZ(k) = z_TempBasicZ(k) * ( 1.0d0 - Weight ) + TempStrat * Weight
!      write(*,*) Weight, tmp, "=>",  z_TempBasicZ(k)
      
      !ٸΨǮٸΨ꾮ʤʤ褦
      DTempDZ = &
        & max( z_DTempDZ(k), (z_TempBasicZ(k) - z_TempBasicZ(k-1)) / r_dz(k-1) )
      
      !ܾβ٤
      z_TempBasicZ(k) = z_TempBasicZ(k-1) + DTempDZ * r_dz(k-1) 
      
      !Ϥſ尵ʿդ׻
      z_PressBasicZ(k) =                                                    &
        &  z_PressBasicZ(k-1) * ( ( z_TempBasicZ(k-1) / z_TempBasicZ(k) )   &
        &    ** (Grav * MolWtDry / ( DTempDZ * GasRUniv ) ) )
    end do
    
  end subroutine initialdata_basic_strat
  

end module initialdata_basic

