!= Module BasicSet
!
! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
! Version::   $Id: basicset.f90,v 1.1 2011-04-26 04:08:10 sugiyama Exp $
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
! ǥեȤδܾꤹ뤿ѿȷ⥸塼
! * BasicEnvFile_init: ܾͤ netCDF ե뤫
! * BasicEnvCalc_Init: ܾξ Namelist ͤ׻
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module basicset
  !
  !ǥեȤδܾꤹ뤿ѿȷ⥸塼
  !, hogeBasicZ Ȥʤ, ͤϤ뤳Ȥ
  !Ԥ. 
  !

  !⥸塼ɤ߹
  use dc_types,   only: DP, STRING
  use dc_iounit,  only: FileOpen
  use dc_message, only: MessageNotify   !å  
  use gridset,    only: imin,       &!  X β
    &                   imax,       &!  X ξ
    &                   jmin,       &!  Z β
    &                   jmax,       &!  Z ξ
    &                   kmin,       &!  Z β
    &                   kmax,       &!  Z ξ
    &                   nf          ! ؼο

  !ۤηػ
  implicit none

  !save °
  private

  !Public Interface
  real(DP), allocatable  :: xyz_DensBasicZ(:,:,:)    !̩
  real(DP), allocatable  :: xyz_PressBasicZ(:,:,:)   !̵
  real(DP), allocatable  :: xyz_ExnerBasicZ(:,:,:)   !̵
  real(DP), allocatable  :: xyz_TempBasicZ(:,:,:)    !
  real(DP), allocatable  :: xyz_PotTempBasicZ(:,:,:) !
  real(DP), allocatable  :: xyz_VelSoundBasicZ(:,:,:)!®
  real(DP), allocatable  :: xyza_MixRtBasicZ(:,:,:,:)!Žʬ
  real(DP), allocatable  :: xyz_EffMolWtBasicZ(:,:,:)!ʬ̸

  save   xyz_DensBasicZ, xyz_PressBasicZ, xyz_ExnerBasicZ, xyz_TempBasicZ, &
    &    xyz_PotTempBasicZ, xyz_VelSoundBasicZ, xyza_MixRtBasicZ, xyz_EffMolWtBasicZ
  public xyz_DensBasicZ, xyz_PressBasicZ, xyz_ExnerBasicZ, xyz_TempBasicZ, &
    &    xyz_PotTempBasicZ, xyz_VelSoundBasicZ, xyza_MixRtBasicZ, xyz_EffMolWtBasicZ
  public basicset_init

contains

!!!-----------------------------------------------------------------!!!
  subroutine basicset_init(                                     &
    & xyz_Press, xyz_Exner, xyz_Temp, xyz_PotTemp, xyz_Dens,    & 
    & xyz_VelSound, xyza_MixRt, xyz_EffMolWt &
    & )
    !
    ! ܾͤ. 
    ! dry ξϺ䴥ʬȶŷʬ¸ۤ˻ȤʤΤ,
    ! ѿ optional ˤƤ. 
    !
    
    !ѿ
    real(DP), intent(in) :: xyz_Press(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyz_Exner(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyz_PotTemp(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyz_Dens(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyz_VelSound(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in), optional :: xyza_MixRt(imin:imax,jmin:jmax,kmin:kmax,nf)
    real(DP), intent(in), optional :: xyz_EffMolWt(imin:imax,jmin:jmax,kmin:kmax)

    ! ν
    call basicset_array_init
    
    !ͤ
    xyz_PressBasicZ    = xyz_Press
    xyz_ExnerBasicZ    = xyz_Exner
    xyz_TempBasicZ     = xyz_Temp
    xyz_PotTempBasicZ  = xyz_PotTemp
    xyz_DensBasicZ     = xyz_Dens
    xyz_VelSoundBasicZ = xyz_VelSound
    if (present(xyza_MixRt))   xyza_MixRtBasicZ = xyza_MixRt
    if (present(xyz_EffMolWt)) xyz_EffMolWtBasicZ = xyz_EffMolWt
    
  end subroutine basicset_init


  subroutine basicset_array_init
    !
    ! *BasicZ ν
    !

    allocate( & 
      & xyz_DensBasicZ    (imin:imax,jmin:jmax,kmin:kmax), &
      & xyz_PressBasicZ   (imin:imax,jmin:jmax,kmin:kmax), &
      & xyz_ExnerBasicZ   (imin:imax,jmin:jmax,kmin:kmax), &
      & xyz_TempBasicZ    (imin:imax,jmin:jmax,kmin:kmax), &
      & xyz_PotTempBasicZ (imin:imax,jmin:jmax,kmin:kmax), &
      & xyz_VelSoundBasicZ(imin:imax,jmin:jmax,kmin:kmax), &
      & xyza_MixRtBasicZ  (imin:imax,jmin:jmax,kmin:kmax,nf), &
      & xyz_EffMolWtBasicZ(imin:imax,jmin:jmax,kmin:kmax)  &
      & )

    ! ͤγ
    xyz_DensBasicZ     = 0.0d0
    xyz_PressBasicZ    = 0.0d0   
    xyz_ExnerBasicZ    = 0.0d0   
    xyz_TempBasicZ     = 0.0d0   
    xyz_PotTempBasicZ  = 0.0d0
    xyz_VelSoundBasicZ = 0.0d0
    xyza_MixRtBasicZ   = 0.0d0
    xyz_EffMolWtBasicZ = 1.0d0 ! dry ξɬ 1.0
    
  end subroutine basicset_array_init
  
end module basicset
