program TestSetup
  use dc_types,    only: DP, STRING
  use mpi_wrapper
  use argset
  use chemdata
  use timeset
  use gridset
  use axesset
  use constants
  use cloudset
  use moistset
  use fileset
  use basicset


  character(STRING) :: cfgfile

  !----------------------------------------------------------------------
  ! 
  !

  ! MPI
  !
  call MPIWrapperInit
  
  ! NAMELIST ե̾ɤ߹
  ! Loading NAMELIST file.
  !
  call argset_init( &
    & cfgfile       & ! (out)
    & )

  ! ν
  ! Initialization of chemical constatns.
  !
  call chemdata_init( )
  
  ! I/O ե̾ν
  ! Initialization of output file name. 
  !
  call fileset_init( &
    & cfgfile        & ! (in)
    & )
  
  ! ʬν
  ! Initialization of time integration.
  !
  call timeset_init( &
    & cfgfile        & ! (in)
    & )
  
  ! ʻν
  ! Initialization of grid arrangement.
  !
  call gridset_init( &
    & cfgfile        & ! (in)
    & )
  
  ! ܾξν
  ! Initialization of basic state variables.
  !
  call axesset_init( &
    & cfgfile        & ! (in)
    & )
  
  ! ͭѿν
  ! Initialization of common variables for moist process.
  !
  call constants_init( cfgfile )

  ! ͭѿν
  ! Initialization of common variables for moist process.
  !
  call moistset_init( cfgfile )

  ! ͭѿν
  ! Initialization of common variables for moist process.
  !
  call cloudset_init( cfgfile )
  

end program TestSetup
