!= Module TimeSet
!
! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
! Version::   $Id: timeset.f90,v 1.2 2011-04-26 04:08:11 sugiyama Exp $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!Ϳ줿 NAMELIST ե뤫, ˴ؤ, 
!ݴɤ뤿ѿ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!

module timeset
  !
  !Ϳ줿 NAMELIST ե뤫, ˴ؤ, 
  !ݴɤ뤿ѿ⥸塼
  !
  
  !⥸塼ɤ߹
  use dc_types,   only: DP
  use dc_iounit,  only: FileOpen
  use dc_message, only: MessageNotify
  use mpi_wrapper, only: myrank
  
  !ۤηػ
  implicit none
  
  ! Public Interface
  real(DP), save, public  :: DelTime      = 2.0d0  !Ĺॹƥå
  real(DP), save, public  :: DelTimeLong  = 2.0d0  !Ĺॹƥå
  real(DP), save, public  :: DelTimeShort = 2.0d-1 !ûॹƥå
  real(DP), save, public  :: StartTime  = 0.0d0    !׻ϻ
  real(DP), save, public  :: EndTime    = 3600.0d0 !׻λ
  integer, save, public   :: NstepLong  = 1800     !ĹॹƥåפΥƥå׿
  integer, save, public   :: NstepShort = 20       !ûॹƥåפΥƥå׿
  
contains
  
  subroutine timeset_init(cfgfile)
    !
    !NAMELIST ɬפʾɤ߼, ִϢѿԤ. 
    !

    !ۤηػ
    implicit none

    !ѿ
    character(*), intent(in)      :: cfgfile

    !ѿ
    integer    :: unit
    integer    :: myrank = 0

    !---------------------------------------------------------------    
    ! NAMELIST 
    !
    NAMELIST /timeset_nml/ &
      & DelTimeLong, DelTimeShort, EndTime, StartTime, DelTime
    
    call FileOpen(unit, file=cfgfile, mode='r')
    read(unit, NML=timeset_nml)
    close(unit)
    
    !---------------------------------------------------------------
    ! 롼ײ
    !
    NstepLong = nint( (EndTime - StartTime) / DelTimeLong )
    NstepShort = 2 * nint( DelTimeLong / DelTimeShort )
    
    !ʬ֤Ĺ֥ƥåפǳڤʤˤϷٹФ
    if(mod((EndTime - StartTime), DelTimeLong) /= 0) then 
      call MessageNotify( "W", &
        & "timeset_init", "mod((EndTime - StartTime), DelTimeLong) is not zero")
    end if
    
    !Ĺ֥ƥåפû֥ƥåפǳڤʤˤϷٹФ
    if(mod(DelTimeLong, DelTimeShort) /= 0) then 
      call MessageNotify( "W", &
        & "timeset_init", "mod(DelTimeLong, DelTimeShort) is not zero")
    end if
    
    !---------------------------------------------------------------
    ! ǧ
    !
    if (myrank == 0) then
      call MessageNotify( "M", &
        & "timeset_init", "DelTimeLong  = %f", d=(/DelTimeLong/) )
      call MessageNotify( "M", &
        & "timeset_init", "DelTimeShort = %f", d=(/DelTimeShort/) )
      call MessageNotify( "M", &
        & "timeset_init", "NstepLong  = %d", i=(/NstepLong/) )
      call MessageNotify( "M", &
        & "timeset_init", "NstepShort = %d", i=(/NstepShort/) )
      call MessageNotify( "M", &
        & "timeset_init", "StartTime  = %f",  d=(/StartTime/)  )
      call MessageNotify( "M", &
        & "timeset_init", "EndTime    = %f", d=(/EndTime/) )
    end if
   
  end subroutine timeset_init
  
end module timeset
